#include <stdio.h>
#include <string.h>
#include <allegro.h>

#include "cpu.h"
#include "keyboard.h"
#include "vmachine.h"
#include "audio.h"
#include "vdc.h"
#include "table.h"
#include "debug.h"
#include "tipi.h"

#if defined(ALLEGRO_WINDOWS)
#include "winalleg.h"
#include <conio.h>
#define KBHIT _kbhit
#elif defined(ALLEGRO_DOS)
#include <conio.h>
#define KBHIT kbhit
#else
#define KBHIT() 0
#endif

static int DisAsm(Indirizzo P);
static void Show_Reg(void);


void Debug(void)
{
	int Done,I,Go,J;
	char Inp[80];
	char *Tok;
	Indirizzo Ad,Run_To;
	char Cr[2],Ff[2];
	Byte D,A;
	
	DbStick1=DbStick2=0;
	Cr[0]=13;
	Cr[1]=0;
	Ff[0]=0x0c;
	Ff[1]=0;
	Done=Go=0;
	
	set_display_switch_mode(SWITCH_BACKGROUND);
	
	if (SndLog)
		fclose(SndLog);
	
	printf("\nEnter in Debug Mode\n\n");
	
	while (!Done)
	{
		while (Go > 0)
		{
			DisAsm(Pc);
			Cpu_Exec();
			
			Go--;
			
			if (KBHIT())
			{
				Go=0;
				
				DisAsm(Pc);
				Show_Reg();
				Cpu_Exec();
			}
		}
		
		printf("> ");
		fgets(Inp,76,stdin);
		
		if ((strlen(Inp)>0) && (Inp[strlen(Inp)-1] == '\n'))
			Inp[strlen(Inp)-1]=0;
		
		strlwr(Inp);
		strcat(Inp," \n");
		Tok=strtok(Inp," ");
		
		if (!Tok)
			Tok="";
		
		if (!strcmp(Tok,"h") || !strcmp(Tok,"?") || !strcmp(Tok,"help"))
		{
			printf("display - show display\n");
			printf("clrkey - clear keypresses\n");
			printf("setkey n - set key n pressed\n");
			printf("s - step\n");
			printf("reg - display registers\n");
			printf("stack - display stack\n");
			printf("video - display VDC registers\n");
			printf("exram - display external RAM contents\n");
			printf("run # - run to address #\n");
			printf("runvb - run to VBL\n");
			printf("runnvb - run to no VBL\n");
			printf("go # - execute # instructions\n");
			printf("intram - display internal ram\n");
			printf("di # - disassemble memory #\n");
			printf("md # - display memory #\n");
			printf("wvdc a d - write data d to VDC address a\n");
			printf("col - display collision table\n");
			printf("stick1 # - set stick1 to #\n");
			printf("stick2 # - set stick2 to #\n");
			printf("sndlog [file] - log raw sound to file\n");
			printf("showfps - display the number of frames per second\n");
			printf("q - quit debugger and return to emulation\n");
			printf("\n");
		}
		else if (!strcmp(Tok,"display"))
			{
				GrMode();
				Clip_Low=0;
				Clip_High=85000;
				
				Draw_Display();
				Finish_Display();
				Init_Keyboard();
				
				do
				{
					rest(1);
				} while((Key_Done == 0) && (!keypressed()));
				
				Set_TextMode();
				set_display_switch_mode(SWITCH_BACKGROUND);
			}
		else if (!strcmp(Tok,"clrkey"))
			for(I=0; I < 128; I++)
				Key2[I]=0;
		else if (!strcmp(Tok,"setkey"))
			{
				Tok=strtok(NULL," ");
				
				if (Tok)
				{
					sscanf(Tok,"%d",&I);
					
					if ((I > 0) && (I < 128))
					{
						printf("Key %d set to pressed\n",I);
						Key2[I]=1;
					}
				}
			}
		else if (!strcmp(Tok,"stick1"))
			{
				Tok=strtok(NULL," ");
				
				if (Tok)
				{
					I=0;
					sscanf(Tok,"%x",&I);
					printf("Stick 1 set to %d\n",I);
					DbStick1=I;
					Key2vCnt=0;
				}
			}
		else if (!strcmp(Tok,"stick2"))
			{
				Tok=strtok(NULL," ");
				
				if (Tok)
				{
					I=0;
					sscanf(Tok,"%x",&I);
					printf("Stick 2 set to %d\n",I);
					DbStick2=I;
					Key2vCnt=0;
				}
			}
		else if (!strcmp(Tok,"s"))
			{
				DisAsm(Pc);
				Show_Reg();
				Cpu_Exec();
			}
		else if (!strcmp(Tok,"reg"))
			Show_Reg();
		else if (!strcmp(Tok,"stack"))
			{
				for(I=8; I < 24; I+=2)
				{
					Ad=IntRam[I];
					D=IntRam[I + 1];
					Ad=Ad | ((D & 0x0F) << 8);
					printf("%x: PC=%x PSW=%x",I,Ad,D);
					
					if (I == Sp)
						printf(" <<SP");
					
					printf("\n");
				}
				
				printf("\n");
			}
		else if (!strcmp(Tok,"q"))
			{
				printf("\nReturning to emulation\n\n");
				Done=1;
			}
		else if (!strcmp(Tok,"pvideo"))
			{
				J=0;
				fprintf(stderr,"%02x:",0);
				
				for(I=0; I < 256; I++)
				{
					fprintf(stderr,"%02x,",VDCWrite[I]);
					J++;
					
					if (J == 16)
					{
						fprintf(stderr,"%s\n",Cr);
						fprintf(stderr,"%02x:",I + 1);
						J=0;
					}
				}
				
				fprintf(stderr,"%s\n",Cr);
				fprintf(stderr,"%s",Ff);
			}
		else if (!strcmp(Tok,"video"))
			{
				J=0;
				printf("%02x:",0);
				
				for(I=0; I < 256; I++)
				{
					printf("%02x",VDCWrite[I]);
					
					if (J < 15)
						printf(",");
					
					J++;
					
					if (J == 16 && I != 255)
					{
						printf("\n");
						printf("%02x:",I + 1);
						J=0;
					}
				}
				
				printf("\n");
			}			
		else if (!strcmp(Tok,"keys"))
			{
				J=0;
				printf("%02x:",0);
				
				for(I=0; I < 128; I++)
				{
					printf("%02x,",Key2[I]);
					J++;
					
					if (J == 16)
					{
						printf("\n");
						printf("%02x:",I + 1);
						J=0;
					}
				}
				
				printf("\n");
			}
		else if (!strcmp(Tok,"col"))
			{
				J=0;
				printf("%02x:",0);
				
				for(I=0; I < 256; I++)
				{
					printf("%02x,",ColTab[I]);
					J++;
					
					if (J == 16)
					{
						printf("\n");
						printf("%02x:",I + 1);
						J=0;
					}
				}
				
				printf("\n");
				printf("Colreg: %x\n ",Ext_Read(0xA2));
			}
		else if (!strcmp(Tok,"exram"))
			{
				J=0;
				printf("%02x:",0);
				
				for(I=0; I < 256; I++)
				{
					printf("%02x",ExtRam[I]);
					
					if (J < 15)
						printf(",");
					
					J++;
					
					if (J == 16 && I !=255)
					{
						printf("\n");
						printf("%02x:",I + 1);
						J=0;
					}
				}
				
				printf("\n\n");
			}
		else if (!strcmp(Tok,"intram"))
			{
				J=0;
				printf("%02x:",0);
			
				for(I=0; I < 64; I++)
				{
					printf("%02x",IntRam[I]);
				
					if (J < 15)
						printf(",");					
				
					J++;
				
					if (J == 16 && I != 63)
					{
						printf("\n");
						printf("%02x:",I + 1);
						J=0;
					}
				}			
				printf("\n\n");
			}		
		else if (!strcmp(Tok,"run"))
			{
				Tok=strtok(NULL," ");
				
				if (Tok)
				{
					sscanf(Tok,"%hx",&Run_To);
					printf("Run to %x\n",Run_To);
					
					while (Pc != Run_To)
					{
						Cpu_Exec();
						
						if (KBHIT())
							break;
					}
					
					DisAsm(Pc);
					Show_Reg();
					Cpu_Exec();
				}
			}
		if (!strcmp(Tok,"runvb"))
			{
				printf("Run to VBL\n");
				
				while (Master_Clk < 5500)
				{
					Cpu_Exec();
					
					if (KBHIT())
						break;
				}
				
				DisAsm(Pc);
				Show_Reg();
				Cpu_Exec();
			}
		else if (!strcmp(Tok,"runnvb"))
			{
				printf("Run to no VBL\n");
				
				while (Master_Clk > 5500)
				{
					Cpu_Exec();
					
					if (KBHIT())
						break;
				}
				
				DisAsm(Pc);
				Show_Reg();
				Cpu_Exec();
			}
		else if (!strcmp(Tok,"wvdc"))
			{
				int T;
			
				Tok=strtok(NULL," ");
			
				if (Tok)
				{
					sscanf(Tok,"%x",&T);
					A=(Byte)T;
					Tok=strtok(NULL," ");
				
					if (Tok)
					{
						sscanf(Tok,"%x",&T);
						D=(Byte)T;
						VDCWrite[A]=D;
					}
				}
			}	
		else if (!strcmp(Tok,"go"))
			{
				Tok=strtok(NULL," ");
				
				if (Tok)
					sscanf(Tok,"%d",&Go);
			}
		else if (!strcmp(Tok,"di"))
			{
				Tok=strtok(NULL," ");
				
				if (Tok)
				{
					Ad=0;
					sscanf(Tok,"%hx",&Ad);
					
					if (Ad < 5100)
					{
						for(I=0; I < 20; I++)
							Ad+=DisAsm(Ad);
					}
					
					printf("\n");
				}
			}
		else if (!strcmp(Tok,"md"))
			{
				Tok=strtok(NULL," ");
				
				if (Tok)
				{
					sscanf(Tok,"%hx",&Ad);
					printf("\n");
					
					for (J=0; J < 10; J++)
						if (Ad + J * 16 < 5100)
						{
							printf("%04x : ",Ad + J * 16);
							
							for (I=0; I < 16; I++)
								printf("%02x ",Rom[Ad + J * 16 + I]);
							
							printf("\n");
						}
						
					printf("\n\n");
				}
			}
		else if (!strcmp(Tok,"sndlog"))
			{
				if (App_Data.Sound_En)
				{
					Tok=strtok(NULL," ");
					
					if (Tok)
					{
						char File[80]="";
						
						sscanf(Tok,"%79s",File);
						
						if (strlen(File) > 0)
						{
							SndLog=fopen(File,"wb");
							
							if (SndLog)
								printf("Sound log file created\n");
							else
								printf("Sound log file creation failed\n");
						}
					}
					
					printf("\n");
				}
				else
					printf("Sound emulation disabled\n\n");				
			}
		else if (!strcmp(Tok,"showfps"))
			Show_Fps=1;
		else if ((strlen(Tok) > 0) && (strcmp(Tok,"\n")))
			printf("Unknown command\n\n");
	}
}

static void Show_Reg(void)
{
	int I;
	Make_Psw_Debug();
	
	printf("PC: %04x  A: %02x PSW: %02x P1: %02x  P2: %02x",Pc,Acc,Psw,P1,P2);
	printf("  clk: %d  reg:%d  count:%x  f:%x\n",Master_Clk,Reg_Pnt,ITimer,Frame);
	
	for (I=0; I < 8; I++)
		printf("R%d: %02x   R%d': %02x\n",I,IntRam[I],I,IntRam[I + 24]);
}

static int DisAsm(Indirizzo P)
{
	Byte Op,D;
	Indirizzo Adr;
	
	Op=Rom[P++];
	printf("%04x: %02x",P - 1,Op);
	
	if (LookUp[Op].Bytes == 2)
		printf(",%02x",Rom[P]);
	
	printf("  %s",LookUp[Op].Mnemonic);
	
	switch(LookUp[Op].Type)
	{
		case 0:
			printf("\n");
			break;
		
		case 1:
			D=Rom[P];
			printf(" #%02x\n",D);
			break;
		
		case 2:
			Adr=Rom[P];
			Adr|=((Op & 0xE0) << 3);
			printf(" $%03x\n",Adr);
			break;
		
		case 3:
			printf(" $%02x\n",Rom[P]);
			break;
	}
	
	return LookUp[Op].Bytes;
}
