#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <allegro.h>

#define FN_FIX_PART			"loempix"

#include "tipi.h"
#include "cpu.h"
#include "vmachine.h"
#include "vdc.h"
#include "audio.h"
#include "voice.h"
#include "vpp.h"
#include "keyboard.h"

int NeedsPool=0;
Byte Keycode;
Byte Last_Key;
Byte Temp;
Byte New_Int=0;

Byte Key_Done=0;
Byte Key_Debug=0;

struct Keyb KeybTab[] = {
	{KEY_A,"A"},
	{KEY_B,"B"},
	{KEY_C,"C"},
	{KEY_D,"D"},
	{KEY_E,"E"},
	{KEY_F,"F"},
	{KEY_G,"G"},
	{KEY_H,"H"},
	{KEY_I,"I"},
	{KEY_J,"J"},
	{KEY_K,"K"},
	{KEY_L,"L"},
	{KEY_M,"M"},
	{KEY_N,"N"},
	{KEY_O,"O"},
	{KEY_P,"P"},
	{KEY_Q,"Q"},
	{KEY_R,"R"},
	{KEY_S,"S"},
	{KEY_T,"T"},
	{KEY_U,"U"},
	{KEY_V,"V"},
	{KEY_W,"W"},
	{KEY_X,"X"},
	{KEY_Y,"Y"},
	{KEY_Z,"Z"},
	{KEY_0,"0"},
	{KEY_1,"1"},
	{KEY_2,"2"},
	{KEY_3,"3"},
	{KEY_4,"4"},
	{KEY_5,"5"},
	{KEY_6,"6"},
	{KEY_7,"7"},
	{KEY_8,"8"},
	{KEY_9,"9"},
	{KEY_0_PAD,"0_PAD"},
	{KEY_1_PAD,"1_PAD"},
	{KEY_2_PAD,"2_PAD"},
	{KEY_3_PAD,"3_PAD"},
	{KEY_4_PAD,"4_PAD"},
	{KEY_5_PAD,"5_PAD"},
	{KEY_6_PAD,"6_PAD"},
	{KEY_7_PAD,"7_PAD"},
	{KEY_8_PAD,"8_PAD"},
	{KEY_9_PAD,"9_PAD"},
	{KEY_TILDE,"TILDE"},
	{KEY_MINUS,"MINUS"},
	{KEY_EQUALS,"EQUALS"},
	{KEY_BACKSPACE,"BACKSPACE"},
	{KEY_TAB,"TAB"},
	{KEY_OPENBRACE,"OPENBRACE"},
	{KEY_CLOSEBRACE,"CLOSEBRACE"},
	{KEY_ENTER,"ENTER"},
	{KEY_COLON,"COLON"},
	{KEY_QUOTE,"QUOTE"},
	{KEY_BACKSLASH,"BACKSLASH"},
	{KEY_BACKSLASH2,"BACKSLASH2"},
	{KEY_COMMA,"COMMA"},
	{KEY_STOP,"STOP"},
	{KEY_SLASH,"SLASH"},
	{KEY_SPACE,"SPACE"},
	{KEY_INSERT,"INSERT"},
	{KEY_DEL,"DEL"},
	{KEY_HOME,"HOME"},
	{KEY_END,"END"},
	{KEY_PGUP,"PGUP"},
	{KEY_PGDN,"PGDN"},
	{KEY_LEFT,"LEFT"},
	{KEY_RIGHT,"RIGHT"},
	{KEY_UP,"UP"},
	{KEY_DOWN,"DOWN"},
	{KEY_SLASH_PAD,"SLASH_PAD"},
	{KEY_ASTERISK,"ASTERISK"},
	{KEY_MINUS_PAD,"MINUS_PAD"},
	{KEY_PLUS_PAD,"PLUS_PAD"},
	{KEY_DEL_PAD,"DEL_PAD"},
	{KEY_ENTER_PAD,"ENTER_PAD"},
	{KEY_PRTSCR,"PRTSCR"},
	{KEY_PAUSE,"PAUSE"},
	{KEY_ABNT_C1,"ABNT_C1"},
	{KEY_YEN,"YEN"},
	{KEY_KANA,"KANA"},
	{KEY_AT,"AT"},
	{KEY_CIRCUMFLEX,"CIRCUMFLEX"},
	{KEY_COLON2,"COLON2"},
	{KEY_KANJI,"KANJI"},
	{KEY_LSHIFT,"LSHIFT"},
	{KEY_RSHIFT,"RSHIFT"},
	{KEY_LCONTROL,"LCONTROL"},
	{KEY_RCONTROL,"RCONTROL"},
	{KEY_ALT,"ALT"},
	{KEY_ALTGR,"ALTGR"},
	{KEY_LWIN,"LWIN"},
	{KEY_RWIN,"RWIN"},
	{KEY_MENU,"MENU"},
	{KEY_SCRLOCK,"SCRLOCK"},
	{KEY_NUMLOCK,"NUMLOCK"},
	{0,""}
};

int JoyKeys[2][5] = {{0,0,0,0,0},{0,0,0,0,0}};
int JoyKeysTab[128];


char *Ret_ScShot_FileName(void)
{
	int P1,P2,P3;
	FILE *F;	
	char *FN;
	
	P1=P2=P3=0;
	FN=(char *)malloc(256);
	
	sprintf(FN, "%s%d%d%d.pcx",FN_FIX_PART,P1,P2,P3);
	
	F=fopen(FN,"rb");	
	
	while (F)
	{
		if (P3 < 10)
			P3++;
		else
		{
			P3=0;
			
			if (P2 < 10)
				P2++;
			else
			{
				P2=0;
				
				if (P1 < 10)
					P1++;
				else
					return NULL;	//Exit at 1000
			}
		}		
		
		fclose(F);		
		sprintf(FN,"%s%d%d%d.pcx",FN_FIX_PART,P1,P2,P3);
		F=fopen(FN,"rb");
	}	
	
	return FN;
}

void Set_DefJoyKeys(int Joy,int Sc)
{
	if (Sc)
		Set_JoyKeys(Joy,KEY_W,KEY_S,KEY_A,KEY_D,KEY_SPACE);
	else
		Set_JoyKeys(Joy,KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,KEY_RSHIFT);
}

void Set_JoyKeys(int Joy,int Up,int Down,int Left,int Right,int Fire)
{
	int I,J;
	
	if ((Joy < 0) || (Joy > 1))
		return;
	
	JoyKeys[Joy][0]=Up;
	JoyKeys[Joy][1]=Down;
	JoyKeys[Joy][2]=Left;
	JoyKeys[Joy][3]=Right;
	JoyKeys[Joy][4]=Fire;
	
	for (I=0; I < 128; I++)
		JoyKeysTab[I]=0;
	
	for (J=0; J < 2; J++)
		for (I=0; I < 5; I++)
		{
			if ((JoyKeys[J][I] < 1) || (JoyKeys[J][I] > 127))
				JoyKeys[J][I]=0;
			else
				JoyKeysTab[JoyKeys[J][I]]=1;
		}
}

void Handle_Key(void)
{
	if (NeedsPool)
		poll_keyboard();	
	
	if (key[KEY_F5])
	{
		Rom=oRom;
		
		Init_Cpu();
		Init_Vpp();
		ClearScr();

		do
		{
			rest(5);
			
			if (NeedsPool)
				poll_keyboard();
		} while (key[KEY_F5]);
	}
	
	if (key[KEY_F4])
		Key_Debug=1;
	
	if (key[KEY_F1])
	{
		do
		{
			rest(5);
			
			if (NeedsPool)
				poll_keyboard();
		} while (key[KEY_F1]);
		
		Mute_Audio();
		Mute_Voice();
		Display_Info();
		
		do
		{
			rest(5);
			
			if (NeedsPool)
				poll_keyboard();
			
			if (key[KEY_ALT] && key[KEY_ENTER])
			{
				App_Data.FullScreen=App_Data.FullScreen ? 0 : 1;
				
				GrMode();
				Display_Info();
				
				do
				{
					rest(5);
					
					if (NeedsPool)
						poll_keyboard();
				} while (key[KEY_ENTER]);
			}
		} while ((!key[KEY_F1]) && (!key[KEY_ESC]) && (!key[KEY_F12]));
		
		do
		{
			rest(5);
			
			if (NeedsPool)
				poll_keyboard();
		} while (key[KEY_F1]);
		
		Init_Sound_Stream();
	}
	
	if (key[KEY_F8])
	{
		BITMAP *Bmp;
		PALETTE Pal;		
		char *FileName;
		
		FileName=Ret_ScShot_FileName();
		
		if (FileName != NULL)
		{
			get_palette(Pal);
			Bmp=create_sub_bitmap(screen, 0, 0, SCREEN_W, SCREEN_H);
			save_pcx(FileName,Bmp,Pal);
			destroy_bitmap(Bmp);
			
			do
			{
				rest(5);
			
				if (NeedsPool)
					poll_keyboard();
			} while (key[KEY_F8]);
		}		
	}
	
	if (key[KEY_F11])
	{
		do
		{
			rest(5);
			
			if (NeedsPool)
				poll_keyboard();
		} while (key[KEY_F1]);		
		
		Close_Audio();
		Close_Voice();
		Set_TextMode();
		Close_Display();
		allegro_exit();
		
		exit(0);
	}
	
	if (key[KEY_ALT] && key[KEY_ENTER])
	{
		App_Data.FullScreen=App_Data.FullScreen ? 0 : 1;
		
		GrMode();
		
		do
		{
			rest(5);
			
			if (NeedsPool)
				poll_keyboard();
		} while (key[KEY_ENTER]);
	}
}

Byte KeyJoy(int Jn)
{
	Byte D=0xFF;
	
	if ((Jn >= 0) && (Jn <= 1))
	{
		if (NeedsPool)
			poll_keyboard();
		
		if (key[JoyKeys[Jn][0]])
			D&=0xFE;
		
		if (key[JoyKeys[Jn][1]])
			D&=0xFB;
		
		if (key[JoyKeys[Jn][2]])
			D&=0xF7;
		
		if (key[JoyKeys[Jn][3]])
			D&=0xFD;
		
		if (key[JoyKeys[Jn][4]])
			D&=0xEF;
	}
	
	return D;
}

void Init_Keyboard(void)
{
	Key_Done=0;
	Key_Debug=0;
	
	install_keyboard();
	
	New_Int=1;	
	NeedsPool=keyboard_needs_poll();
}

void Set_Old_Int9(void)
{
	remove_keyboard();
	New_Int=0;	
}
